#!/bin/bash
#
# updates by WIPAT 2554-09-01
# updates by WIBOON 2556-02-22
#
# exit 0 is valid ; exit > 0 is invalid

CHECK_BLACKLIST="YES"
BLACKLIST_FILE="/etc/freeradius/blacklist.txt"
ALL_PASS="YES"
CHECK_VIPLIST="NO"
VIP_FILE="/etc/freeradius/viplist.txt"
CHECK_PSU_STAFF="NO"
CHECK_PSU_STUDENT="NO"

export LANG=en.US
MYDIR="/var/log/freeradius/myauthen"
if [ ! -d ${MYDIR} ] ; then
  mkdir -p ${MYDIR}
fi
TODAY=$(date "+%Y%m%d")
MYFILE="${MYDIR}/${TODAY}"
if [ ! -e ${MYFILE} ] ; then
  touch ${MYFILE}
fi
MYTIME=$(echo $1|awk '{print strftime("%Y%m%d:%H:%M:%S",$1)}')
MYUSER=$(echo $USER_NAME | cut -d'"' -f2)
#uncomment to debug
#printenv > /tmp/exec-program-wait
if [ "${CHECK_BLACKLIST}" = "YES" ] ; then
  if [ -s ${BLACKLIST_FILE} ] ; then
    OUTPUT=$(grep "^${MYUSER}\$" ${BLACKLIST_FILE})
    if [ -n "${OUTPUT}" ] ; then
      echo "blacklist"
      exit 9
    fi
  fi
fi
if [ "${ALL_PASS}" = "YES" ] ; then
  exit 0
fi 
if [ "${CHECK_VIPLIST}" = "YES" ] ; then
  if [ -s ${VIP_FILE} ] ; then
    OUTPUT=$(grep "^${MYUSER}\$" ${VIP_FILE})
    if [ -n "${OUTPUT}" ] ; then
      echo "viplist allow"
      exit 0
    fi
  fi
fi
if [ "${CHECK_PSU_STAFF}" = "YES" ] ; then
  OUTPUT=$(echo "${MYUSER}"|grep "@")
  if [ -z "${OUTPUT}" ] ; then
    OUTPUT=$(echo "${MYUSER}"|grep "^[[:digit:]]")
    if [ -z "${OUTPUT}" ] ; then
      echo "psu_staff allow"
      exit 0
    fi
  else
    OUTPUT=$(echo "${MYUSER}"|grep "psu.ac.th")
    if [ -n "${OUTPUT}" ] ; then
      echo "psu_staff allow"
      exit 0
    fi
  fi
fi
if [ "${CHECK_PSU_STUDENT}" = "YES" ] ; then
  OUTPUT=$(echo "${MYUSER}"|grep "@")
  if [ -z "${OUTPUT}" ] ; then
    MYSTUDENT="....."
#    MYSTUDENT="..105"
    OUTPUT=$(echo "${MYUSER}"|grep "^${MYSTUDENT}")
    if [ -n "${OUTPUT}" ] ; then
      echo "psu_student allow"
      exit 0
    fi
  fi
fi
echo "not allow"
exit 7
#
